<?php
/**
* @version com_phocadownload.php 110 2010-01-26
* @package sh404SEF
* @copyright Copyright (C) 2009 Maksin.ms
* @copyright Copyright (C) 2010 Johan Lindh
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
* @author Johan Lindh
* @link www.linkdata.se
*
* Based on code by Branislav Maksin (www.maksin.ms).
*
* This plugin for sh404SEF will generate SEF URL's
* of the form menuitem/section/category/file
*
* It supports nested categories, since the Phoca Download
* database structure allows this, even if there is no
* administrative functions for them.
*
**/

defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

// ------------------  standard plugin initialize function - don't change ---------------------------
global $sh_LANG, $sefConfig, $database;
$shLangName = '';
$shLangIso = '';
$title = array();
$shItemidString = '';
$dosef = shInitializePlugin( $lang, $shLangName, $shLangIso, $option);
if ($dosef == false) return;
// ------------------  standard plugin initialize function - don't change ---------------------------

// ------------------  load language file - adjust as needed ----------------------------------------
//$shLangIso = shLoadPluginLanguage( 'com_phocadownload', $shLangIso, '_SEF_PhocaDownload_TEXT_STRING');
// ------------------  load language file - adjust as needed ----------------------------------------

if( !function_exists( 'shPhocaDownloadSectionName' )) {
	function shPhocaDownloadSectionName( $section_id ) {
		$sefConfig = &shRouter::shGetConfig();
 		$database = &JFactory::getDBO();
		$database->setQuery( "SELECT title FROM #__phocadownload_sections WHERE id = ".$section_id );
		return str_replace( '.', $sefConfig->replacement, $database->loadResult() );
		}
	}
	
if( !function_exists( 'shPhocaDownloadCategorySection' )) {
	function shPhocaDownloadCategorySection( $category_id ) {
		$sefConfig = &shRouter::shGetConfig();
		$database = &JFactory::getDBO();
		$database->setQuery( "SELECT section FROM #__phocadownload_categories WHERE id = ".$category_id );
		return str_replace( '.', $sefConfig->replacement, $database->loadResult() );
		}
	}

if( !function_exists( 'shPhocaDownloadCategoryName' )) {
	function shPhocaDownloadCategoryName( $category_id ) {
		$sefConfig = &shRouter::shGetConfig();
		$database = &JFactory::getDBO();
		$fullname = array();
		$database->setQuery( "SELECT parent_id FROM #__phocadownload_categories WHERE id = ".$category_id );
		$parent_id = $database->loadResult();
		if( !empty($parent_id) ) $fullname = array_merge( $fullname, shPhocaDownloadCategoryName($parent_id) );
		$database->setQuery( "SELECT title FROM #__phocadownload_categories WHERE id = ".$category_id );
		$name = str_replace( '.', $sefConfig->replacement, $database->loadResult() );
		$fullname[] = $name;
		return $fullname;
		}
	}

if (!function_exists( 'shPhocaDownloadFile')) {
	function shPhocaDownloadFile($download_id) {
		$sefConfig = &shRouter::shGetConfig();
		$database = &JFactory::getDBO();
		$database->setQuery( "SELECT title FROM #__phocadownload WHERE id = " . $download_id );
		return str_replace( '.', $sefConfig->replacement, $database->loadResult() );
		}
	}

if (!function_exists( 'shPhocaDownloadMenuName')) {
	function shPhocaDownloadMenuName($task,$Itemid) {
		$sefConfig = &shRouter::shGetConfig();
		$shPhocaDownloadName = shGetComponentPrefix($option);
		if( empty($shPhocaDownloadName) ) $shPhocaDownloadName = getMenuTitle($option, $task, $Itemid, null, $shLangName);
		if( empty($shPhocaDownloadName) || $shPhocaDownloadName == '/' ) $shPhocaDownloadName = 'PhocaDownload';
		return str_replace( '.', $sefConfig->replacement, $shPhocaDownloadName );
		}
	}


// remove common URL from GET vars list, so that they don't show up as query string in the URL
shRemoveFromGETVarsList('option');
shRemoveFromGETVarsList('lang');
shRemoveFromGETVarsList('view');
shRemoveFromGETVarsList('id');
if( isset($Itemid) ) shRemoveFromGETVarsList('Itemid');

// make sure we don't error out on accessing undefined variables
$task = isset($task) ? @$task : null;
$Itemid = isset($Itemid) ? @$Itemid : null;
$title[] = shPhocaDownloadMenuName($task,$Itemid);

switch ($view) {
	case 'section':
		$title[] = shPhocaDownloadSectionName($id);
		break;
	case 'category':
		$title[] = shPhocaDownloadSectionName( shPhocaDownloadCategorySection($id) );
		$title = array_merge( $title, shPhocaDownloadCategoryName($id) );
		break;
	}

if( !empty($download) ) {
	$title[] = shPhocaDownloadFile($download);
	shRemoveFromGETVarsList('download');
	}
else {
	$title[] = '/';
	}

// ------------------  standard plugin finalize function - don't change ---------------------------
if ($dosef) {
	$string = shFinalizePlugin( $string, $title, $shAppendString, $shItemidString,
		(isset($limit) ? @$limit : null), (isset($limitstart) ? @$limitstart : null),
		(isset($shLangName) ? @$shLangName : null));
	}
// ------------------  standard plugin finalize function - don't change ---------------------------

?>
